

#include <stdlib.h>
//#include <iostream.h>
extern "C" {
  int printf(char*, ...) ;
}
extern "C" {
  #include "mpi.h"
}
#include "Threads.h"

Threads* ths ;


Threads :: ThreadStack :: ThreadStack(const int _numThreads,
				      ThreadStack* _parent) :
	    numThreads(_numThreads), parent(_parent) {
  events  = new MPI_Request [numThreads] ;
  servers = new Server* [numThreads] ;
}

Threads :: ThreadStack :: ~ThreadStack() {
  delete servers ;
  delete events ;
}


Threads :: Threads() {
  thrStk = new ThreadStack(1, NULL) ;
  thrStk->events [0] = MPI_REQUEST_NULL ;
}

Threads :: ~Threads() {
  delete thrStk ;
}

int Threads :: allocateServerGroup(const int n) {
  ThreadStack* oldStk = thrStk ;
  const int oldNum = oldStk->numThreads ;
  const int newNum = oldNum + n ;

  thrStk = new ThreadStack(newNum, oldStk) ;
  for(int i = 0 ; i < oldNum ; i++) {
    thrStk->events  [i] = oldStk->events  [i] ;
    thrStk->servers [i] = oldStk->servers [i] ;
  }
  for(i = oldNum ; i < newNum ; i++)
    thrStk->events  [i] = MPI_REQUEST_NULL ;

  return oldNum ;
}

void Threads :: deallocateServerGroup() {
  ThreadStack* oldStk = thrStk->parent ;
  delete thrStk ;
  thrStk = oldStk ;
}

void Threads :: installServer(const int threadId, Server* server) {
  thrStk->servers [threadId] = server ;
}

MPI_Request* Threads :: event(const int threadId) {
  return thrStk->events + threadId ;
}

void Threads :: waitEvent(const int threadId) {
  // Wait until event in specified thread succeeds

  int eventId ;
  MPI_Status status ;

  MPI_Waitany(thrStk->numThreads, thrStk->events, &eventId, &status) ;
  while(eventId != threadId) {
    (thrStk->servers [eventId])->transition(&status) ;

    MPI_Waitany(thrStk->numThreads, thrStk->events, &eventId, &status) ;
  }
}

void Threads :: waitServerTransition() {
  // Wait until a server transition occurs

  int serverId ;
  MPI_Status status ;

  MPI_Waitany(thrStk->numThreads - 1, thrStk->events + 1,
	      &serverId, &status) ;
  (thrStk->servers [serverId + 1])->transition(&status) ;
}

